-- demo.ex
--
-- Translate from C to Euphoria by Normand M. Blais
-- date: December 1998
-- Reference:
--      "Graphics Programming in Turbo C 2.0" by Ben Ezzel.
-- 
-- This demo program is from the book mentionned above.
-- The first part shows a simple turtle drwing demontration.
-- The second part show the effect of wrapping.
-- The last part uses the procedure drawstr to write charaters
-- on the screen scaled differently.
--
include get.e
include turtle.e

procedure pause()
    integer k
    k = wait_key()
end procedure

procedure turtle_demo()
   home()
   hide_turtle()
   turtle_delay(10)
   set_heading(SOUTH)
   pen_up()
   forward(100)
   delay(50)

   turtle_delay(0)
   pen_down()
   set_heading(45)      
   for i=1 to 15 do
       set_pen_color(i)
       for j=1 to 6 do
           forward(100+i*3)
           turn_right(59)
       end for
   end for      
   home()             
   pause()
   clear_turtle_screen(BLACK)
   wrap_()
   set_position(-100,-100)
   set_heading(45)
   for i=1 to 15 do
       set_pen_color(i)
       for j=1 to 3 do
           forward(200)
           turn_left(90)
       end for
       forward(200)
   end for      
   home() 
   no_wrap()
   pause()
end procedure

procedure turtle_write(integer x, integer y, integer scale, integer color,
                       sequence str)
   sequence logo
   logo = "pcma8a8b2c8c8c8e8e8f2g8g8g8a8a8c8c8c8" &
          "f2g0g0e5b2c0c0a5f2e3g9g9a3g2e5c7c8c7" &
          "f2g0g0e5b2c0c0a5f2e3g9g9a3g2e5c8c8c8pcd"
   if color <= maxcolor then
       set_pen_color(color)
   end if
   if scale <= 0 then
       scale = 1    
   end if
   set_position(x,y)
   for i=1 to length(str) do
       if get_key() != -1 then
          if graphics_mode(-1) then
          end if              
          abort(0)
       end if
       if color < 0 then
           set_pen_color(rand(maxcolor-1))    
       end if
       if str[i] = ' ' then
           drawstr(scale,"pc6")
       elsif str[i] = 'e' then
           drawstr(scale,"pbama6b2c4d2e2f2g4edc3bc" &
                         "ef2g4h2pb2a3mbc2dfg2hpd7")
       elsif str[i] = 'i' then
           drawstr(scale,"pcma9bpamhabdefpemde9g2pc3")
       elsif str[i] = 'l' then
           drawstr(scale,"pbma7a7bde7e7fhpdc2")
       elsif str[i] = 'r' then
           drawstr(scale,"pcma9bce2b2c2d2eghg2f2e6g2pc9")
       elsif str[i] = 't' then
           drawstr(scale,"pb2cma8g3hbc3a3bde3c3dfg3" &
                         "e7dcdfg2h2pd2c5")
       elsif str[i] = 'u' then
           drawstr(scale,"pbama7bde6dc2ba6bde7deghf" &
                         "g4h2pd2c7")
       elsif str[i] = 'w' then
           drawstr(scale,"pbama7bde6dc2ba3bde3dc2b" &
                         "a6bde7f2g4hfg4h2pd2c6c7")
       end if
   end for                                       
   drawstr(scale,logo)
end procedure         

procedure turtle_write_demo()
   turtle_delay(0) --10)
   turtle_write(-300,-110,5,maxcolor-1,"turtle write")
   turtle_delay(0) --7)
   turtle_write(-300,-20,4,rand(maxcolor-1),"write turtle")
   turtle_delay(0) --5)
   turtle_write(-300,55,3,-1,"turtle write")
   turtle_delay(0)--3)
   turtle_write(-300,110,2,-1,"write turtle")
   turtle_delay(0)--1)
   turtle_write(-300,150,1,maxcolor-1,
            "turtle write turtle write turtle write turtle write turtle")
   home()   
   pause()
end procedure

procedure main()
   init_turtle()
   turtle_demo()
   clear_turtle_screen(BLACK)
   turtle_write_demo()
   end_turtle() 
end procedure

main()

